@isTest
private class TestChangeRequestTriggerHandler {
    
    static TriggerContol__c  triggerctrl ;
    static Team__c baseTeam, overlayTeam ;
    static Team_Instance__c baseTeamInstance, overlayTeamInstance ;
    static Position__c nation, region, district, territory, territoryOverlay ;
    static Position_Team_Instance__c territoryTeamInstance, territoryTeamInstanceOverlay ;
    static User hoUser1 ;
    static  Change_Request_Type__c newPositionReqType, newPositionReqType1, newPositionReqType2, newPositionReqType3, newPositionReqType4, newPositionReqType5, newPositionReqType6 ;
    static Account childAccount, parentAccount;

    static {

        list<Profile> hoProfile = [SELECT Id FROM Profile WHERE Name =: SalesIQGlobalConstants.HR_PROFILE limit 1];
        if(hoProfile.size() == 0){
            hoProfile = [SELECT Id FROM Profile WHERE Name = 'System Administrator' limit 1];
        }
        
        hoUser1 = new User(LastName = 'ho',
                            FirstName='test',
                            Alias = 'test',
                            Email = 'test.ho@test.com',
                            Username = 'test.ho@test.com',
                            ProfileId = hoProfile[0].id,
                            TimeZoneSidKey = 'GMT',
                            LanguageLocaleKey = 'en_US',
                            EmailEncodingKey = 'UTF-8',
                            LocaleSidKey = 'en_US');
        insert hoUser1; 

        triggerctrl =  new TriggerContol__c(IsStopTrigger__c=false , Name='ChangeRequestTrigger');
        insert triggerctrl;

        baseTeam = new Team__c(Name='HTN',Type__c='Base',Effective_End_Date__c=Date.today().addMonths(50));
        insert baseTeam;
        
        overlayTeam = new Team__c(Name='HTN Overlay',Type__c='Overlay',Controlling_Team__c= baseTeam.id);
        insert overlayTeam;

        Affiliation_Network__c affNetworkObj = new Affiliation_Network__c(Name='Group Practice');
        insert affNetworkObj;

        baseTeamInstance = new Team_Instance__c();
        baseTeamInstance.Name = 'HTN_Q1_2016';
        baseTeamInstance.Alignment_Period__c = 'HTN_Q1_2016';
        baseTeamInstance.Team__c = baseTeam.id;
        baseTeamInstance.IC_EffstartDate__c = Date.today();
        baseTeamInstance.IC_EffendDate__c = Date.today();
        baseTeamInstance.Alignment_Type__c = 'ZIP';
        baseTeamInstance.isActiveCycle__c = 'Y';    
        baseTeamInstance.Affiliation_Network__c = affNetworkObj.Id;
        
        overlayTeamInstance = new Team_Instance__c();
        overlayTeamInstance.Name = 'HTN_Overlay_2016';
        overlayTeamInstance.Alignment_Period__c = 'HTN_Overlay_2016';
        overlayTeamInstance.Team__c = overlayTeam.id;
        overlayTeamInstance.Alignment_Type__c = 'ZIP';
        overlayTeamInstance.IC_EffstartDate__c = Date.today();
        overlayTeamInstance.IC_EffendDate__c = Date.today();
        overlayTeamInstance.isActiveCycle__c = 'Y';     
        
        insert new Team_Instance__c[]{baseTeamInstance, overlayTeamInstance};

        nation = new Position__c();
        nation.name = 'USA';
        nation.Client_Territory_Name__c = 'North east';
        nation.Client_Position_Code__c = '1NE30000';
        nation.Client_Territory_Code__c='1NE30000';
        nation.Position_Type__c='Nation';
        nation.inactive__c = false;
        nation.RGB__c = '41,210,117';
        nation.Team_iD__c = baseTeam.id;
        nation.Effective_End_Date__c=Date.today().addMonths(50);
        nation.Hierarchy_Level__c = '4';
        insert nation;
        
        region = new Position__c();
        region.name = 'North east';
        region.Client_Territory_Name__c = 'North east';
        region.Client_Position_Code__c = 'Terr0001';
        region.Client_Territory_Code__c='1NE30000';
        region.Position_Type__c='Region';
        region.inactive__c = false;
        region.RGB__c = '41,210,117';
        region.Team_iD__c = baseTeam.id;
        region.Effective_End_Date__c=Date.today().addMonths(50);
        region.Hierarchy_Level__c = '3';
        region.Parent_Position__c = nation.Id;
        insert region;

        district = new Position__c();
        district.name = 'Newyork';
        district.Client_Territory_Name__c = 'Newyork';
        district.Client_Position_Code__c = '1NE30001';
        district.Client_Territory_Code__c='1NE30001';
        district.Position_Type__c='District';
        district.inactive__c = false;
        district.RGB__c = '41,210,117';
        district.Team_iD__c = baseTeam.id;
        district.Parent_Position__c = region.Id;
        district.Effective_End_Date__c=Date.today().addMonths(50);
        district.Hierarchy_Level__c = '2';
        district.Related_Position_Type__c = 'Base';
        insert district ;

        territory = new Position__c();
        territory.name = 'Long Island East';
        territory.Client_Territory_Name__c = 'Long Island East';
        territory.Client_Position_Code__c = '1NE30011';
        territory.Client_Territory_Code__c='1NE30011';
        territory.Position_Type__c='Territory';
        territory.inactive__c = false;
        territory.RGB__c = '41,210,117';
        territory.Team_iD__c = baseTeam.id;
        territory.Parent_Position__c = district.Id;
        territory.Effective_End_Date__c=Date.today().addMonths(50);
        territory.Effective_Start_Date__c=Date.today().addMonths(50);
        territory.Related_Position_Type__c = 'Base';
        territory.Hierarchy_Level__c = '1';
        insert territory;

        territoryOverlay = new Position__c();
        territoryOverlay.name = 'Long Island East';
        territoryOverlay.Client_Territory_Name__c = 'Long Island East';
        territoryOverlay.Client_Position_Code__c = '1NE400';
        territoryOverlay.Client_Territory_Code__c='1NE400';
        territoryOverlay.Position_Type__c='Territory';
        territoryOverlay.inactive__c = false;
        territoryOverlay.RGB__c = '41,210,117';
        territoryOverlay.Team_iD__c = overlayTeam.id;
        territoryOverlay.Parent_Position__c = district.Id;
        territoryOverlay.Effective_End_Date__c=Date.today().addMonths(50);
        territoryOverlay.Effective_Start_Date__c=Date.today().addMonths(50);
        territoryOverlay.Related_Position_Type__c = 'Overlay';
        territoryOverlay.Hierarchy_Level__c = '1';
        insert territoryOverlay;


        Position_Team_Instance__c nationTeamInstance = CallPlanTestDataFactory.CreatePosTeamInstance(nation, null, baseTeamInstance);
        nationTeamInstance.X_Max__c=-72.6966429900;
        nationTeamInstance.X_Min__c=-73.9625820000;
        nationTeamInstance.Y_Max__c=40.9666490000;
        nationTeamInstance.Y_Min__c=40.5821279800;

        Position_Team_Instance__c regionTeamInstance = CallPlanTestDataFactory.CreatePosTeamInstance(region, nation, baseTeamInstance);
        regionTeamInstance.X_Max__c=-72.6966429900;
        regionTeamInstance.X_Min__c=-73.9625820000;
        regionTeamInstance.Y_Max__c=40.9666490000;
        regionTeamInstance.Y_Min__c=40.5821279800;
        
        Position_Team_Instance__c districtTeamInstance = CallPlanTestDataFactory.CreatePosTeamInstance(district, region, baseTeamInstance);
        districtTeamInstance.X_Max__c=-72.6966429900;
        districtTeamInstance.X_Min__c=-73.9625820000;
        districtTeamInstance.Y_Max__c=40.9666490000;
        districtTeamInstance.Y_Min__c=40.5821279800;
        
        territoryTeamInstance = CallPlanTestDataFactory.CreatePosTeamInstance(territory, district, baseTeamInstance);
        territoryTeamInstance.X_Max__c=-72.6966429900;
        territoryTeamInstance.X_Min__c=-73.9625820000;
        territoryTeamInstance.Y_Max__c=40.9666490000;
        territoryTeamInstance.Y_Min__c=40.5821279800;

        territoryTeamInstanceOverlay = CallPlanTestDataFactory.CreatePosTeamInstance(territoryOverlay, district, overlayTeamInstance);
        territoryTeamInstanceOverlay.X_Max__c=-72.6966429900;
        territoryTeamInstanceOverlay.X_Min__c=-73.9625820000;
        territoryTeamInstanceOverlay.Y_Max__c=40.9666490000;
        territoryTeamInstanceOverlay.Y_Min__c=40.5821279800;
        
        insert new Position_Team_Instance__c[]{nationTeamInstance, regionTeamInstance, districtTeamInstance, territoryTeamInstance, territoryTeamInstanceOverlay};

        Position__c destTerr = new Position__c();
        destTerr.Name = 'Long Island West';
        destTerr.Client_Territory_Name__c = 'Long Island West';
        destTerr.Client_Position_Code__c = '1NE30012';
        destTerr.Client_Territory_Code__c='1NE30012';
        destTerr.Position_Type__c='Territory';
        destTerr.inactive__c = false;
        destTerr.RGB__c = '41,210,117';
        destTerr.Team_iD__c = baseTeam.id;
        destTerr.Parent_Position__c = district.Id;
        destTerr.Effective_End_Date__c=Date.today().addMonths(50);
        destTerr.Hierarchy_Level__c = '1';

        Position__c unassignedTerritory = new Position__c();
        unassignedTerritory.Name = 'Unassigned Territory';
        unassignedTerritory.Client_Territory_Name__c = 'Unassigned (Terr00000)';
        unassignedTerritory.Client_Position_Code__c = SalesIQGlobalConstants.UNASSIGNED_TERRITORY_CODE;
        unassignedTerritory.Client_Territory_Code__c=SalesIQGlobalConstants.UNASSIGNED_TERRITORY_CODE;
        unassignedTerritory.Position_Type__c='Territory';
        unassignedTerritory.inactive__c = false;
        unassignedTerritory.RGB__c = '41,210,117';
        unassignedTerritory.Team_iD__c = baseTeam.id;
        unassignedTerritory.Effective_End_Date__c=Date.today().addMonths(50);
        unassignedTerritory.Hierarchy_Level__c = '1';
        unassignedTerritory.Related_Position_Type__c = 'Base';

        Position__c unassignedOverlayTerritory = new Position__c();
        unassignedOverlayTerritory.Name = 'Unassigned Territory';
        unassignedOverlayTerritory.Client_Territory_Name__c = 'Unassigned Overlay(OveralyTerr00000)';
        unassignedOverlayTerritory.Client_Position_Code__c = SalesIQGlobalConstants.UNASSIGNED_TERRITORY_CODE;
        unassignedOverlayTerritory.Client_Territory_Code__c=SalesIQGlobalConstants.UNASSIGNED_TERRITORY_CODE;
        unassignedOverlayTerritory.Position_Type__c='Territory';
        unassignedOverlayTerritory.inactive__c = false;
        unassignedOverlayTerritory.RGB__c = '41,210,117';
        unassignedOverlayTerritory.Team_iD__c = overlayTeam.id;
        unassignedOverlayTerritory.Effective_End_Date__c=Date.today().addMonths(50);
        unassignedOverlayTerritory.Hierarchy_Level__c = '1';
        unassignedOverlayTerritory.Related_Position_Type__c = 'Overlay';
        
        insert new Position__c[] {destTerr, unassignedTerritory, unassignedOverlayTerritory};


        Position_Team_Instance__c destTerrTeamInstance = CallPlanTestDataFactory.CreatePosTeamInstance(destTerr, district, baseTeamInstance);
        destTerrTeamInstance.X_Max__c=-72.6966429900;
        destTerrTeamInstance.X_Min__c=-73.9625820000;
        destTerrTeamInstance.Y_Max__c=40.9666490000;
        destTerrTeamInstance.Y_Min__c=40.5821279800;

        
        Position_Team_Instance__c unassignedTerrTeamInstance = CallPlanTestDataFactory.CreatePosTeamInstance(unassignedTerritory, district, baseTeamInstance);
        unassignedTerrTeamInstance.X_Max__c=-72.6966429900;
        unassignedTerrTeamInstance.X_Min__c=-73.9625820000;
        unassignedTerrTeamInstance.Y_Max__c=40.9666490000;
        unassignedTerrTeamInstance.Y_Min__c=40.5821279800;
        
        
        Position_Team_Instance__c unassignedOverlayTerrTeamInstance = CallPlanTestDataFactory.CreatePosTeamInstance(unassignedOverlayTerritory, district, overlayTeamInstance);
        unassignedOverlayTerrTeamInstance.X_Max__c=-72.6966429900;
        unassignedOverlayTerrTeamInstance.X_Min__c=-73.9625820000;
        unassignedOverlayTerrTeamInstance.Y_Max__c=40.9666490000;
        unassignedOverlayTerrTeamInstance.Y_Min__c=40.5821279800;

        insert new Position_Team_Instance__c[]{destTerrTeamInstance, unassignedTerrTeamInstance, unassignedOverlayTerrTeamInstance};


        Related_Position__c relatedposDest1st=CallPlanTestDataFactory.createRelatedPos(territoryTeamInstance,territoryTeamInstanceOverlay,territoryOverlay, territory);
        Related_Position__c relatedposDest2nd=CallPlanTestDataFactory.createRelatedPos(unassignedTerrTeamInstance,unassignedOverlayTerrTeamInstance,unassignedOverlayTerritory, unassignedTerritory);
        insert new Related_Position__c[]{relatedposDest1st,relatedposDest2nd};

        childAccount = new Account();
        childAccount.name = 'Child Account';
        childAccount.FirstName__c = 'Child';
        childAccount.LastName__c = 'Account';
        childAccount.BillingCity = 'NJ';
        childAccount.BillingState = 'NY';
        childAccount.AccountNumber = '11788';
        childAccount.type = 'Physician';
        childAccount.Speciality__c = '11788Oncology';
        insert childAccount;

        parentAccount = new Account();
        parentAccount.name = 'Parent Account';
        parentAccount.FirstName__c = 'Parent';
        parentAccount.LastName__c = 'Account';
        parentAccount.BillingCity = 'NJ';
        parentAccount.BillingState = 'NY';
        parentAccount.AccountNumber = '11790';
        parentAccount.type = 'Physician';
        parentAccount.Speciality__c = '11790Oncology';
        insert parentAccount;

        Account_Affiliation__c accAffiliationObj = new Account_Affiliation__c(Account__c = childAccount.Id, Parent_Account__c = parentAccount.Id, Root_Account__c = parentAccount.Id, Affiliation_Network__c = affNetworkObj.Id);
        insert accAffiliationObj;

        Account_Affiliation__c accAffiliationObjParent = new Account_Affiliation__c(Account__c = parentAccount.Id, Root_Account__c = parentAccount.Id, Affiliation_Network__c = affNetworkObj.Id);
        insert accAffiliationObjParent;
    }

    static void testConfigDataCreate(){

        Team_Instance_Object_Attribute__c teamInstAttr =  new Team_Instance_Object_Attribute__c();
        teamInstAttr.Interface_Name__c = 'Alignment: Create Position Popup';
        teamInstAttr.Attribute_API_Name__c = 'Name';
        teamInstAttr.Object_Name__c = 'Position__c';
        teamInstAttr.Data_Type__c = 'Text';
        teamInstAttr.Attribute_Display_Name__c = 'Label.PositionName';
        teamInstAttr.isEnabled__c = true;
        teamInstAttr.isEditable__c = true;
        teamInstAttr.IsAutoSuggested__c  = false;
        teamInstAttr.isRequired__c   = true;
        teamInstAttr.Team_Instance__c = baseTeamInstance.Id;
        teamInstAttr.Display_Column_Order__c = 1;
        //insert teamInstAttr;
        
        Team_Instance_Object_Attribute__c teamInstAttr8 =  new Team_Instance_Object_Attribute__c();
        teamInstAttr8.Interface_Name__c = 'Alignment: Create Position Popup';
        teamInstAttr8.Attribute_API_Name__c = SalesIQGlobalConstants.NAME_SPACE  + 'Effective_start_Date__c';
        teamInstAttr8.Object_Name__c = 'Position__c';
        teamInstAttr8.Data_Type__c = 'Date';
        teamInstAttr8.Attribute_Display_Name__c = 'Label.Effective_Start_Date';
        teamInstAttr8.isEnabled__c = true;
        teamInstAttr8.isEditable__c = true;
        teamInstAttr8.IsAutoSuggested__c     = true;
        teamInstAttr8.isRequired__c  = true;
        teamInstAttr8.Team_Instance__c = baseTeamInstance.Id;
        teamInstAttr8.Display_Column_Order__c = 1;
        
        Team_Instance_Object_Attribute__c teamInstAttr9 =  new Team_Instance_Object_Attribute__c();
        teamInstAttr9.Interface_Name__c = 'Alignment: Create Position Popup';
        teamInstAttr9.Attribute_API_Name__c = SalesIQGlobalConstants.NAME_SPACE  + 'Effective_End_Date__c';
        teamInstAttr9.Object_Name__c = 'Position__c';
        teamInstAttr9.Data_Type__c = 'Text';
        teamInstAttr9.Attribute_Display_Name__c = 'Label.Effective_End_Date';
        teamInstAttr9.isEnabled__c = true;
        teamInstAttr9.isEditable__c = true;
        teamInstAttr9.IsAutoSuggested__c     = true;
        teamInstAttr9.isRequired__c  = true;
        teamInstAttr9.Team_Instance__c = baseTeamInstance.Id;
        teamInstAttr9.Display_Column_Order__c = 1;
        
        Team_Instance_Object_Attribute__c teamInstAttr11 =  new Team_Instance_Object_Attribute__c();
        teamInstAttr11.Interface_Name__c = 'Alignment: Create Position Popup';
        teamInstAttr11.Attribute_API_Name__c = SalesIQGlobalConstants.NAME_SPACE  + 'Effective_start_Date__c';
        teamInstAttr11.Object_Name__c = 'Position__c';
        teamInstAttr11.Data_Type__c = 'Date';
        teamInstAttr11.Attribute_Display_Name__c = 'Label.Effective_Start_Date';
        teamInstAttr11.isEnabled__c = true;
        teamInstAttr11.isEditable__c = true;
        teamInstAttr11.IsAutoSuggested__c    = true;
        teamInstAttr11.isRequired__c     = true;
        teamInstAttr11.Team_Instance__c = OverlayTeamInstance.Id;
        teamInstAttr11.Display_Column_Order__c = 1;
        
        Team_Instance_Object_Attribute__c teamInstAttr10 =  new Team_Instance_Object_Attribute__c();
        teamInstAttr10.Interface_Name__c = 'Alignment: Create Position Popup';
        teamInstAttr10.Attribute_API_Name__c = SalesIQGlobalConstants.NAME_SPACE  + 'Effective_End_Date__c';
        teamInstAttr10.Object_Name__c = 'Position__c';
        teamInstAttr10.Data_Type__c = 'Text';
        teamInstAttr10.Attribute_Display_Name__c = 'Label.Effective_End_Date';
        teamInstAttr10.isEnabled__c = true;
        teamInstAttr10.isEditable__c = true;
        teamInstAttr10.IsAutoSuggested__c    = true;
        teamInstAttr10.isRequired__c     = true;
        teamInstAttr10.Team_Instance__c = OverlayTeamInstance.Id;
        teamInstAttr10.Display_Column_Order__c = 1;

        
        Team_Instance_Object_Attribute__c teamInstAttr14 =  new Team_Instance_Object_Attribute__c();
        teamInstAttr14.Interface_Name__c = 'Alignment: Edit Position Popup';
        teamInstAttr14.Attribute_API_Name__c = SalesIQGlobalConstants.NAME_SPACE  + 'Effective_start_Date__c';
        teamInstAttr14.Object_Name__c = 'Position__c';
        teamInstAttr14.Data_Type__c = 'Date';
        teamInstAttr14.Attribute_Display_Name__c = 'Label.Effective_Start_Date';
        teamInstAttr14.isEnabled__c = true;
        teamInstAttr14.isEditable__c = true;
        teamInstAttr14.IsAutoSuggested__c    = true;
        teamInstAttr14.isRequired__c     = true;
        teamInstAttr14.Team_Instance__c = baseTeamInstance.Id;
        teamInstAttr14.Display_Column_Order__c = 1;
        
        String ns = SalesIQGlobalConstants.getOrgNameSpace();
        
        Team_Instance_Object_Attribute__c teamInstAttr1 =  new Team_Instance_Object_Attribute__c();
        teamInstAttr1.Interface_Name__c = 'Alignment: Create Position Popup';
        teamInstAttr1.Attribute_API_Name__c = ns+'Client_Position_Code__c';
        teamInstAttr1.Object_Name__c = 'Position__c';
        teamInstAttr1.Data_Type__c = 'Text';
        teamInstAttr1.Attribute_Display_Name__c = 'Label.PositionCode';
        teamInstAttr1.isEnabled__c = true;
        teamInstAttr1.isEditable__c = true;
        teamInstAttr1.IsAutoSuggested__c     = true;
        teamInstAttr1.isRequired__c  = true;
        teamInstAttr1.Team_Instance__c = baseTeamInstance.Id;
        teamInstAttr1.Display_Column_Order__c = 2;
        
        Team_Instance_Object_Attribute__c teamInstAttr2 =  new Team_Instance_Object_Attribute__c();
        teamInstAttr2.Interface_Name__c = 'Alignment: Edit Position Popup';
        teamInstAttr2.Attribute_API_Name__c = ns+'Client_Position_Code__c';
        teamInstAttr2.Object_Name__c = 'Position__c';
        teamInstAttr2.Data_Type__c = 'Text';
        teamInstAttr2.Attribute_Display_Name__c = 'Label.PositionCode';
        teamInstAttr2.isEnabled__c = true;
        teamInstAttr2.isEditable__c = true;
        teamInstAttr2.IsAutoSuggested__c     = true;
        teamInstAttr2.isRequired__c  = true;
        teamInstAttr2.Team_Instance__c = baseTeamInstance.Id;
        teamInstAttr2.Display_Column_Order__c = 2;
        
        Team_Instance_Object_Attribute__c teamInstAttr3 =  new Team_Instance_Object_Attribute__c();
        teamInstAttr3.Interface_Name__c = 'Alignment: Edit Position Popup';
        teamInstAttr3.Attribute_API_Name__c = 'Name';
        teamInstAttr3.Object_Name__c = 'Position__c';
        teamInstAttr3.Data_Type__c = 'Text';
        teamInstAttr3.Attribute_Display_Name__c = 'Label.PositionName';
        teamInstAttr3.isEnabled__c = true;
        teamInstAttr3.isEditable__c = true;
        teamInstAttr3.IsAutoSuggested__c     = true;
        teamInstAttr3.isRequired__c  = true;
        teamInstAttr3.Team_Instance__c = baseTeamInstance.Id;
        teamInstAttr3.Display_Column_Order__c = 1;
        
        
        Team_Instance_Object_Attribute__c teamInstAttr4 =  new Team_Instance_Object_Attribute__c();
        teamInstAttr4.Interface_Name__c = 'Alignment: Create Position Popup';
        teamInstAttr4.Attribute_API_Name__c = 'Name';
        teamInstAttr4.Object_Name__c = 'Position__c';
        teamInstAttr4.Data_Type__c = 'Text';
        teamInstAttr4.Attribute_Display_Name__c = 'Label.PositionName';
        teamInstAttr4.isEnabled__c = true;
        teamInstAttr4.isEditable__c = true;
        teamInstAttr4.IsAutoSuggested__c     = false;
        teamInstAttr4.isRequired__c  = true;
        teamInstAttr4.Team_Instance__c = overlayTeamInstance.Id;
        teamInstAttr4.Display_Column_Order__c = 1;
        
        Team_Instance_Object_Attribute__c teamInstAttr5 =  new Team_Instance_Object_Attribute__c();
        teamInstAttr5.Interface_Name__c = 'Alignment: Create Position Popup';
        teamInstAttr5.Attribute_API_Name__c = ns+'Client_Position_Code__c';
        teamInstAttr5.Object_Name__c = 'Position__c';
        teamInstAttr5.Data_Type__c = 'Text';
        teamInstAttr5.Attribute_Display_Name__c = 'Label.PositionCode';
        teamInstAttr5.isEnabled__c = true;
        teamInstAttr5.isEditable__c = true;
        teamInstAttr5.IsAutoSuggested__c     = true;
        teamInstAttr5.isRequired__c  = true;
        teamInstAttr5.Team_Instance__c = overlayTeamInstance.Id;
        teamInstAttr5.Display_Column_Order__c = 2;
        
        Team_Instance_Object_Attribute__c teamInstAttr6 =  new Team_Instance_Object_Attribute__c();
        teamInstAttr6.Interface_Name__c = 'Alignment: Edit Position Popup';
        teamInstAttr6.Attribute_API_Name__c = ns+'Client_Position_Code__c';
        teamInstAttr6.Object_Name__c = 'Position__c';
        teamInstAttr6.Data_Type__c = 'Text';
        teamInstAttr6.Attribute_Display_Name__c = 'Label.PositionCode';
        teamInstAttr6.isEnabled__c = true;
        teamInstAttr6.isEditable__c = true;
        teamInstAttr6.IsAutoSuggested__c     = true;
        teamInstAttr6.isRequired__c  = true;
        teamInstAttr6.Team_Instance__c = overlayTeamInstance.Id;
        teamInstAttr6.Display_Column_Order__c = 2;
        
        Team_Instance_Object_Attribute__c teamInstAttr7 =  new Team_Instance_Object_Attribute__c();
        teamInstAttr7.Interface_Name__c = 'Alignment: Edit Position Popup';
        teamInstAttr7.Attribute_API_Name__c = 'Name';
        teamInstAttr7.Object_Name__c = 'Position__c';
        teamInstAttr7.Data_Type__c = 'Text';
        teamInstAttr7.Attribute_Display_Name__c = 'Label.PositionName';
        teamInstAttr7.isEnabled__c = true;
        teamInstAttr7.isEditable__c = true;
        teamInstAttr7.IsAutoSuggested__c     = true;
        teamInstAttr7.isRequired__c  = true;
        teamInstAttr7.Team_Instance__c = overlayTeamInstance.Id;
        teamInstAttr7.Display_Column_Order__c = 1;

        insert new Team_Instance_Object_Attribute__c[]{teamInstAttr, teamInstAttr1, teamInstAttr2, teamInstAttr3, teamInstAttr4, teamInstAttr5,
                    teamInstAttr6, teamInstAttr7,teamInstAttr8,teamInstAttr9,teamInstAttr10,teamInstAttr11};
        
        
        string teamID = baseTeam.id;
        if(teamId.length() > 15){
            teamID = teamID.left(15);
        }

        string teamInstanceID = baseTeamInstance.id;
        if(teamInstanceID.length() > 15){
            teamInstanceID = teamInstanceID.left(15);
        }

        Team_Instance_Configuration__c teamInsConfTerr = new Team_Instance_Configuration__c();
        teamInsConfTerr.Configuration_Type__c = 'Client Position Code' ;
        teamInsConfTerr.name = 'TerrConfig';
        teamInsConfTerr.Hierarchy_Level__c = '1';
        teamInsConfTerr.Pattern_Value__c = 'Terr{0000}';
        teamInsConfTerr.Position_Type__c = 'Territory';
        teamInsConfTerr.Team__c = teamID;
        teamInsConfTerr.Team_Instance__c = teamInstanceID;
         
        Team_Instance_Configuration__c teamInsConfDistr = new Team_Instance_Configuration__c();
        teamInsConfDistr.Configuration_Type__c = 'Client Position Code' ;
        teamInsConfDistr.name = 'DistrictConfig';
        teamInsConfDistr.Hierarchy_Level__c = '2';
        teamInsConfDistr.Pattern_Value__c = 'Dist{0000}';
        teamInsConfDistr.Position_Type__c = 'District';
        teamInsConfDistr.Team__c = teamID;
        teamInsConfDistr.Team_Instance__c = teamInstanceID;

        insert new Team_Instance_Configuration__c[]{teamInsConfTerr, teamInsConfDistr};
        
        CR_Team_Instance_Config__c crTeamInstConf = new CR_Team_Instance_Config__c();
        crTeamInstConf.Configuration_Value__c = 'Territory';
        crTeamInstConf.Configuration_Type__c = 'Hierarchy Configuration';
        crTeamInstConf.Configuration_Name__c = '1';
        crTeamInstConf.team_instance__c = baseTeamInstance.id;
        
        CR_Team_Instance_Config__c crTeamInstConfDistrict = new CR_Team_Instance_Config__c();
        crTeamInstConfDistrict.Configuration_Value__c = 'District';
        crTeamInstConfDistrict.Configuration_Type__c = 'Hierarchy Configuration';
        crTeamInstConfDistrict.Configuration_Name__c = '2';
        crTeamInstConfDistrict.team_instance__c = baseTeamInstance.id;

        insert new CR_Team_Instance_Config__c[]{crTeamInstConf, crTeamInstConfDistrict} ;
        
        newPositionReqType =  CallPlanTestDataFactory.CreateRequestType(SalesIQGlobalConstants.ROSTER);
        newPositionReqType1 =  CallPlanTestDataFactory.CreateRequestType(SalesIQGlobalConstants.DELETE_POSITION);
        newPositionReqType2 =  CallPlanTestDataFactory.CreateRequestType(SalesIQGlobalConstants.Update_POSITION);
        newPositionReqType3 =  CallPlanTestDataFactory.CreateRequestType(SalesIQGlobalConstants.Create_POSITION);
        insert new Change_Request_Type__c[]{newPositionReqType, newPositionReqType1, newPositionReqType2, newPositionReqType3};
        
        CR_Approval_Config__c appConfig = new CR_Approval_Config__c(Team_Instance_ID__c = baseTeamInstance.Id, Change_Request_Type__c = newPositionReqType.Id, HO_Office_User__c = 'Y', HR_User__c = 'N', IsImpactedPosition__c = false, isHigherLevelManagers__c = false, isImpactedManager__c = false);
        CR_Approval_Config__c appConfig1 = new CR_Approval_Config__c(Team_Instance_ID__c = baseTeamInstance.Id, Change_Request_Type__c = newPositionReqType1.Id, HO_Office_User__c = 'Y', HR_User__c = 'N', IsImpactedPosition__c = false, isHigherLevelManagers__c = false, isImpactedManager__c = false);
        CR_Approval_Config__c appConfig2 = new CR_Approval_Config__c(Team_Instance_ID__c = baseTeamInstance.Id, Change_Request_Type__c = newPositionReqType2.Id, HO_Office_User__c = 'Y', HR_User__c = 'N', IsImpactedPosition__c = false, isHigherLevelManagers__c = false, isImpactedManager__c = false);
        CR_Approval_Config__c appConfig3 = new CR_Approval_Config__c(Team_Instance_ID__c = baseTeamInstance.Id, Change_Request_Type__c = newPositionReqType3.Id, HO_Office_User__c = 'Y', HR_User__c = 'N', IsImpactedPosition__c = false, isHigherLevelManagers__c = false, isImpactedManager__c = false);
        insert new CR_Approval_Config__c[]{appConfig, appConfig1, appConfig2, appConfig3};
        
        
        newPositionReqType4 =  CallPlanTestDataFactory.CreateRequestType(SalesIQGlobalConstants.DELETE_Overlay_POSITION);
        newPositionReqType5 =  CallPlanTestDataFactory.CreateRequestType(SalesIQGlobalConstants.Update_Overlay_POSITION);
        newPositionReqType6 =  CallPlanTestDataFactory.CreateRequestType(SalesIQGlobalConstants.Create_Overlay_POSITION);
        insert new Change_Request_Type__c[]{newPositionReqType4, newPositionReqType5, newPositionReqType6}; 

        CR_Approval_Config__c appConfig5 = new CR_Approval_Config__c(Team_Instance_ID__c = overlayTeamInstance.Id, Change_Request_Type__c = newPositionReqType4.Id, HO_Office_User__c = 'Y', HR_User__c = 'N', IsImpactedPosition__c = false, isHigherLevelManagers__c = false, isImpactedManager__c = false);
        CR_Approval_Config__c appConfig6 = new CR_Approval_Config__c(Team_Instance_ID__c = overlayTeamInstance.Id, Change_Request_Type__c = newPositionReqType5.Id, HO_Office_User__c = 'Y', HR_User__c = 'N', IsImpactedPosition__c = false, isHigherLevelManagers__c = false, isImpactedManager__c = false);
        CR_Approval_Config__c appConfig7 = new CR_Approval_Config__c(Team_Instance_ID__c = overlayTeamInstance.Id, Change_Request_Type__c = newPositionReqType6.Id, HO_Office_User__c = 'Y', HR_User__c = 'N', IsImpactedPosition__c = false, isHigherLevelManagers__c = false, isImpactedManager__c = false);
        insert new CR_Approval_Config__c[]{appConfig5, appConfig6, appConfig7};
        
        TotalApproval__c totalApp = new TotalApproval__c(Name='Approvals',No_Of_Approval__c=3);
        insert totalApp;
        
    }

    Static testMethod Void testProcessAccountAlignmentType(){

        Change_Request__c accMovementCR = new Change_Request__c();
        accMovementCR.Approver3__c = hoUser1.id;
        accMovementCR.Approver1__c = hoUser1.id;
        accMovementCR.Approver2__c = hoUser1.id;
        accMovementCR.Status__c = 'Approved';
        accMovementCR.Destination_Position__c = territory.id;
        accMovementCR.Source_Position__c = territory.id;
        accMovementCR.Team_Instance_ID__c = baseTeamInstance.id;
        /*Change_Request_Type__c accountMovementReqType =  CallPlanTestDataFactory.CreateRequestType(SalesIQGlobalConstants.MOVEMENT_TYPE_ACCOUNT);
        accMovementCR.RecordTypeID__c= accountMovementReqType.id;
        accMovementCR.Request_Type_Change__c = SalesIQGlobalConstants.MOVEMENT_TYPE_ACCOUNT;*/
        accMovementCR.Change_Effective_Date__c = System.today();
        accMovementCR.Account_Moved_Id__c = (String) childAccount.AccountNumber;
        insert accMovementCR;

        System.debug('--accMovementCR ' + accMovementCR);
        
        baseTeamInstance.Alignment_Type__c = SalesIQGlobalConstants.ALIGNMENT_TYPE_ACCOUNT;
        baseTeamInstance.Enable_Affiliation_Movement__c = true;
        update baseTeamInstance;

        /*Team_Instance_Account__c teamInsObj = CallPlanTestDataFactory.createTeamInstanceAccount(childAccount, baseTeamInstance);
        insert teamInsObj;*/
        insert CallPlanTestDataFactory.createPositionAccount(childAccount, territory, baseTeamInstance, territoryTeamInstance);

        /*Team_Instance_Account__c teamInsObjParent = CallPlanTestDataFactory.createTeamInstanceAccount(parentAccount, baseTeamInstance);
        insert teamInsObjParent;*/
        insert CallPlanTestDataFactory.createPositionAccount(parentAccount, territory, baseTeamInstance, territoryTeamInstance);

        ChangeRequestTriggerHandler.processAccountAlignmentType(new Set<Id>{accMovementCR.Id});
    }

    // Create new Overlay Position case
    static testMethod void testCreateOverlayPosition() {

        testConfigDataCreate();

        Change_Request__c zipChangeRequest = new Change_Request__c();
        zipChangeRequest.Approver3__c = hoUser1.id;
        zipChangeRequest.Approver1__c = hoUser1.id;
        zipChangeRequest.Approver2__c = hoUser1.id;
        zipChangeRequest.Status__c = 'Pending';
        zipChangeRequest.Destination_Position__c = territoryOverlay.id;
        zipChangeRequest.Source_Position__c = territoryOverlay.id;
        zipChangeRequest.Team_Instance_ID__c = overlayTeamInstance.id;
        zipChangeRequest.RecordTypeID__c= newPositionReqType6.id;
        zipChangeRequest.Request_Type_Change__c = SalesIQGlobalConstants.Create_Overlay_POSITION;
        zipChangeRequest.Change_Effective_Date__c = System.today();
        //ZipChangeRequest.AllZips__c = '11099,12388,13077,19977';
        insert zipChangeRequest;
        
        CR_Position__c CRPos = CallPlanTestDataFactory.createCRPosition(zipChangeRequest);  
        CRPos.position__c = territoryOverlay.id;  

        CR_Position__c CRPos2 = CallPlanTestDataFactory.createCRPosition(zipChangeRequest);  
        CRPos2.position__c = territory.id;  

        insert new CR_Position__c[]{CRPos, CRPos2};
   
        Test.setMock(HttpCalloutMock.class, new ESRIServicesMockGenerator());
        test.startTest() ;
        
        //ChangeRequestTriggerHandler.setAlreadyExecuted();
        Boolean b = ChangeRequestTriggerHandler.isAlreadyExecuted(); 
       
        zipChangeRequest.Status__c = 'Approved';
        update zipChangeRequest;
        
        test.stopTest();
    }

    // Update base position case
    static testMethod void testUpdatePosition() {

        testConfigDataCreate();

        Change_Request__c zipChangeRequest = new Change_Request__c();
        zipChangeRequest.Approver3__c = hoUser1.id;
        zipChangeRequest.Approver1__c = hoUser1.id;
        zipChangeRequest.Approver2__c = hoUser1.id;
        zipChangeRequest.Status__c = 'Pending';
        zipChangeRequest.Destination_Position__c = territory.id;
        zipChangeRequest.Source_Position__c = territory.id;
        zipChangeRequest.Team_Instance_ID__c = baseTeamInstance.id;
        zipChangeRequest.RecordTypeID__c= newPositionReqType2.id;
        zipChangeRequest.Request_Type_Change__c = SalesIQGlobalConstants.Update_POSITION;
        zipChangeRequest.Change_Effective_Date__c = System.today();
        //zipChangeRequest.AllZips__c = '11099,12388,13077,19977';
        insert zipChangeRequest;
        
        CR_Position__c CRPos2 = CallPlanTestDataFactory.createCRPosition(zipChangeRequest);  
        CRPos2.position__c = territory.id;  
        CRPos2.position_team_instance__r = territoryTeamInstance ;
        CRPos2.Position_Change_String__c = '[{"fieldValue":"Central Jersey","fieldApiName":"Name"}]' ;

        insert CRPos2;
   
        Test.setMock(HttpCalloutMock.class, new ESRIServicesMockGenerator());
        test.startTest() ;
        
        //ChangeRequestTriggerHandler.setAlreadyExecuted();
        Boolean b = ChangeRequestTriggerHandler.isAlreadyExecuted(); 
       
        zipChangeRequest.Status__c = 'Approved';
        update zipChangeRequest;
        
        test.stopTest();
    }

    // Update base position case
    static testMethod void testHierarchyChange() {

        testConfigDataCreate();

        Change_Request__c zipChangeRequest = new Change_Request__c();
        zipChangeRequest.Approver3__c = hoUser1.id;
        zipChangeRequest.Approver1__c = hoUser1.id;
        zipChangeRequest.Approver2__c = hoUser1.id;
        zipChangeRequest.Status__c = 'Pending';
        zipChangeRequest.Destination_Position__c = territory.id;
        zipChangeRequest.Source_Position__c = territory.id;
        zipChangeRequest.Team_Instance_ID__c = baseTeamInstance.id;
        zipChangeRequest.RecordTypeID__c= newPositionReqType2.id;
        zipChangeRequest.Request_Type_Change__c = SalesIQGlobalConstants.HIERARCHY_CHANGE;
        zipChangeRequest.Change_Effective_Date__c = System.today();
        //zipChangeRequest.AllZips__c = '11099,12388,13077,19977';
        insert zipChangeRequest;

        Related_Position__c newRelatedPosObj = new Related_Position__c();
        newRelatedPosObj.Base_Position__c = territory.id;
        newRelatedPosObj.Effective_Start_Date__c = Date.today();
        newRelatedPosObj.Effective_End_Date__c = Date.today() + 1;
        newRelatedPosObj.Base_Position_Team_Instance__c = territoryTeamInstance.id;
        newRelatedPosObj.Related_Position_Team_Instance__c = territoryTeamInstanceOverlay.id;
        newRelatedPosObj.Related_Position__c = territoryOverlay.id;
        newRelatedPosObj.isActive__c = true;
        newRelatedPosObj.Related_Position_Type__c = SalesIqGlobalConstants.TEAM_TYPE_OVERLAY;
        insert newRelatedPosObj;
                                
        CR_Position__c CRPos2 = CallPlanTestDataFactory.createCRPosition(zipChangeRequest);  
        CRPos2.position__c = territory.id;  
        CRPos2.future_reporting_position__c = district.id;
        CRPos2.position_team_instance__r = territoryTeamInstance ;
        CRPos2.Position_Change_String__c = '[{"fieldValue":"Central Jersey","fieldApiName":"Name"}]' ;

        insert CRPos2;
   
        Test.setMock(HttpCalloutMock.class, new ESRIServicesMockGenerator());
        test.startTest() ;
        
        //ChangeRequestTriggerHandler.setAlreadyExecuted();
        Boolean b = ChangeRequestTriggerHandler.isAlreadyExecuted(); 
       
        /*zipChangeRequest.Status__c = 'Approved';
        update zipChangeRequest;*/

        zipChangeRequest.Team_Instance_ID__c = overlayTeamInstance.id;
         zipChangeRequest.Source_Position__c = territoryOverlay.id;
        zipChangeRequest.Request_Type_Change__c = SalesIQGlobalConstants.HIERARCHY_CHANGE_OVERLAY;
        zipChangeRequest.status__c = 'Pending';
        update zipChangeRequest;

        zipChangeRequest.Team_Instance_ID__c = overlayTeamInstance.id;
        /*zipChangeRequest.status__c = 'Approved';
        update zipChangeRequest;*/
        
        test.stopTest();
    }

    static testMethod void testUpdateOverlayPosition() {

        testConfigDataCreate();
        
        Change_Request__c zipChangeRequest = new Change_Request__c();
        zipChangeRequest.Approver3__c = hoUser1.id;
        zipChangeRequest.Approver1__c = hoUser1.id;
        zipChangeRequest.Approver2__c = hoUser1.id;
        zipChangeRequest.Status__c = 'Pending';
        zipChangeRequest.Destination_Position__c = territoryOverlay.id;
        zipChangeRequest.Source_Position__c = territoryOverlay.id;
        zipChangeRequest.Team_Instance_ID__c = overlayTeamInstance.id;
        zipChangeRequest.RecordTypeID__c= newPositionReqType5.id;
        zipChangeRequest.Request_Type_Change__c = SalesIQGlobalConstants.UPDATE_OVERLAY_POSITION;
        zipChangeRequest.Change_Effective_Date__c = System.today();
       // zipChangeRequest.AllZips__c = '11099,12388,13077,19977';
        insert zipChangeRequest;
        
        CR_Position__c CRPos = CallPlanTestDataFactory.createCRPosition(zipChangeRequest);  
        CRPos.position__c = territory.id;  
        CRPos.Position_Team_Instance__c = territoryTeamInstance.id;
        
        CR_Position__c CRPos2 = CallPlanTestDataFactory.createCRPosition(zipChangeRequest);  
        CRPos2.position__c = territoryOverlay.id;  
        CRPos2.position_team_instance__c = territoryTeamInstanceOverlay.Id ;
        CRPos2.Position_Change_String__c = '[{"fieldValue":"Central Jersey","fieldApiName":"Name"}]' ;

        insert new CR_Position__c[]{CRPos, CRPos2};
   
        Test.setMock(HttpCalloutMock.class, new ESRIServicesMockGenerator());
        test.startTest() ;
        
        //ChangeRequestTriggerHandler.setAlreadyExecuted();
        Boolean b = ChangeRequestTriggerHandler.isAlreadyExecuted(); 
       
        zipChangeRequest.Status__c = 'Approved';
        update zipChangeRequest;
        
        test.stopTest();
    }

    static testMethod void testUpdateOverlayPosition2() {

        testConfigDataCreate();
        
        Change_Request__c zipChangeRequest = new Change_Request__c();
        zipChangeRequest.Approver3__c = hoUser1.id;
        zipChangeRequest.Approver1__c = hoUser1.id;
        zipChangeRequest.Approver2__c = hoUser1.id;
        zipChangeRequest.Status__c = 'Pending';
        zipChangeRequest.Destination_Position__c = territoryOverlay.id;
        zipChangeRequest.Source_Position__c = territoryOverlay.id;
        zipChangeRequest.Team_Instance_ID__c = overlayTeamInstance.id;
        zipChangeRequest.RecordTypeID__c= newPositionReqType5.id;
        zipChangeRequest.Request_Type_Change__c = SalesIQGlobalConstants.UPDATE_OVERLAY_POSITION;
        zipChangeRequest.Change_Effective_Date__c = System.today();
        //zipChangeRequest.AllZips__c = '11099,12388,13077,19977';
        insert zipChangeRequest;
        
        CR_Position__c CRPos2 = CallPlanTestDataFactory.createCRPosition(zipChangeRequest);  
        CRPos2.position__c = territoryOverlay.id;  
        CRPos2.position_team_instance__c = territoryTeamInstanceOverlay.Id ;
        CRPos2.Position_Change_String__c = '[{"fieldValue":"Central Jersey","fieldApiName":"Name"}]' ;

        insert CRPos2;
   
        Test.setMock(HttpCalloutMock.class, new ESRIServicesMockGenerator());
        test.startTest() ;
        
        //ChangeRequestTriggerHandler.setAlreadyExecuted();
        Boolean b = ChangeRequestTriggerHandler.isAlreadyExecuted(); 
       
        zipChangeRequest.Status__c = 'Approved';
        update zipChangeRequest;
        
        test.stopTest();
    }

    static testMethod void testEditOverlayPosition() {

        testConfigDataCreate();

        Change_Request__c zipChangeRequest = new Change_Request__c();
        zipChangeRequest.Approver3__c = hoUser1.id;
        zipChangeRequest.Approver1__c = hoUser1.id;
        zipChangeRequest.Approver2__c = hoUser1.id;
        zipChangeRequest.Status__c = 'Pending';
        zipChangeRequest.Destination_Position__c = territoryOverlay.id;
        zipChangeRequest.Source_Position__c = territoryOverlay.id;
        zipChangeRequest.Team_Instance_ID__c = overlayTeamInstance.id;
        zipChangeRequest.RecordTypeID__c= newPositionReqType5.id;
        zipChangeRequest.Request_Type_Change__c = SalesIQGlobalConstants.UPDATE_OVERLAY_POSITION;
        zipChangeRequest.Change_Effective_Date__c = System.today();
        //zipChangeRequest.AllZips__c = '11099,12388,13077,19977';
        insert zipChangeRequest;
        
        CR_Position__c CRPos = CallPlanTestDataFactory.createCRPosition(zipChangeRequest);  
        CRPos.position__c = territory.id;  
        CRPos.Position_Team_Instance__c = territoryTeamInstance.id;
        insert CRPos;
        
        CR_Position__c CRPos2 = CallPlanTestDataFactory.createCRPosition(zipChangeRequest);  
        CRPos2.position__c = territoryOverlay.id;  
        CRPos2.Position_Team_Instance__c = territoryTeamInstance.id;
        insert CRPos2;
   
        Test.setMock(HttpCalloutMock.class, new ESRIServicesMockGenerator());
        test.startTest() ;
        
        //ChangeRequestTriggerHandler.setAlreadyExecuted();
        Boolean b = ChangeRequestTriggerHandler.isAlreadyExecuted(); 
       
        zipChangeRequest.Status__c = 'Approved';
        update zipChangeRequest;
        
        test.stopTest();
    }

    static testMethod void testDeletePosition() {

        testConfigDataCreate();

        Change_Request__c zipChangeRequest = new Change_Request__c();
        zipChangeRequest.Approver3__c = hoUser1.id;
        zipChangeRequest.Approver1__c = hoUser1.id;
        zipChangeRequest.Approver2__c = hoUser1.id;
        zipChangeRequest.Status__c = 'Pending';
        zipChangeRequest.Destination_Position__c = territory.id;
        zipChangeRequest.Source_Position__c = territory.id;
        zipChangeRequest.Team_Instance_ID__c = baseTeamInstance.id;
        zipChangeRequest.RecordTypeID__c= newPositionReqType4.id;
        zipChangeRequest.Request_Type_Change__c = SalesIQGlobalConstants.DELETE_POSITION;
        zipChangeRequest.AllZips__c = '11099,12388,13077,19977';
        insert zipChangeRequest;
        
   
        Test.setMock(HttpCalloutMock.class, new ESRIServicesMockGenerator());
        test.startTest() ;
        
        //ChangeRequestTriggerHandler.setAlreadyExecuted();
        Boolean b = ChangeRequestTriggerHandler.isAlreadyExecuted(); 
       
        zipChangeRequest.Status__c = 'Approved';
        update zipChangeRequest;
        
        test.stopTest();
    }

    
    static testMethod void testEmployeeAssignmentPosition() {

        testConfigDataCreate();

        Change_Request__c zipChangeRequest = new Change_Request__c();
        zipChangeRequest.Approver3__c = hoUser1.id;
        zipChangeRequest.Approver1__c = hoUser1.id;
        zipChangeRequest.Approver2__c = hoUser1.id;
        zipChangeRequest.Status__c = 'Pending';
        zipChangeRequest.Destination_Position__c = territory.id;
        zipChangeRequest.Source_Position__c = territory.id;
        zipChangeRequest.Team_Instance_ID__c = baseTeamInstance.id;
        zipChangeRequest.RecordTypeID__c= newPositionReqType.id;
        zipChangeRequest.Request_Type_Change__c = SalesIQGlobalConstants.EMPLOYEE_ASSIGNMENT;
        insert zipChangeRequest;


        Employee__c empChosen = new Employee__c();
        empChosen.Name = 'Test Empl';
        empChosen.Employee_ID__c = '12345';
        empChosen.Last_Name__c = 'Empl';
        empChosen.FirstName__c = 'Test';
        empChosen.Gender__c = 'M';
        empChosen.Change_status__c = 'Pending';
        insert empChosen;

        Position_Employee__c p = new Position_Employee__c();
        p.employee__c= empChosen.id;
        p.position__c = territory.id;
        p.assignment_type__c='None';
        p.reason_code__c='None';
        p.isNew__c = true;
        p.Effective_Start_Date__c = Date.Today();
        p.Effective_End_Date__c = Date.today() + 1;
        p.status__c = 'Pending';
        insert p;
                
        Employee_Status__c objEmpStas = new Employee_Status__c();
        objEmpStas.Employee__c = empChosen.id;
        objEmpStas.Employee_Status__c = 'Assigned';
        objEmpStas.Effective_Start_Date__c = date.today();
        objEmpStas.Effective_End_Date__c = date.today();
        insert objEmpStas;

        list<CR_Employee_Assignment__c> crEmpAssgList = SalesIQUtility.createCRempAssgn(zipChangeRequest, new list<Position_Employee__c>{p});
        insert crEmpAssgList;
        
   
        Test.setMock(HttpCalloutMock.class, new ESRIServicesMockGenerator());
        test.startTest() ;
        
        //ChangeRequestTriggerHandler.setAlreadyExecuted();
        Boolean b = ChangeRequestTriggerHandler.isAlreadyExecuted(); 
       
        zipChangeRequest.Status__c = 'Approved';
        update zipChangeRequest;
        
        test.stopTest();
    }
    
}